import java.awt.Graphics;
import java.awt.Toolkit;
import java.awt.color.ColorSpace;
import java.awt.image.BufferedImage;
import java.awt.image.ColorConvertOp;
import java.awt.image.ConvolveOp;
import java.awt.image.Kernel;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.JFrame;
import javax.swing.WindowConstants;

import com.jhlabs.image.*;


public class ImageView extends JFrame{
	BufferedImage srcImg;  //das Bild, das wir einlesen
	BufferedImage dstImg;  //das gefilterte Bild
	
	public ImageView(){
		setSize(1000,720);
		this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		
		//Bild einlesen
		//srcImg = ImageRead.readJPEG(ImageRead.filename);
		srcImg = ImageRead.readImageStream(ImageRead.filename);
		//ausprobieren, welche Methode funktioniert (kann auch erst spter beim Filtern zu Problemen kommen, 
		//dann andere Methode ausprobieren)
		
		double screenWidth = Toolkit.getDefaultToolkit().getScreenSize().getWidth();
		double screenHeight = Toolkit.getDefaultToolkit().getScreenSize().getHeight();

		// 30px for window borders...
		if ((srcImg.getWidth(null)*2 + 30) > screenWidth)
		{
			double scale = (screenWidth - 30) / (srcImg.getWidth(null)*2);
			int newWidth =  (int)(scale * srcImg.getWidth(null));
			int newHeight = (int)(scale * srcImg.getHeight(null));
			
			BufferedImage tmpImg = new BufferedImage(newWidth, newHeight, BufferedImage.TYPE_INT_ARGB);
			tmpImg.getGraphics().drawImage(srcImg, 0,0, newWidth, newHeight, null);
			srcImg = new BufferedImage(newWidth, newHeight, BufferedImage.TYPE_INT_ARGB);
			srcImg.getGraphics().drawImage(tmpImg, 0,0, newWidth, newHeight, null);
			
			this.setSize(newWidth*2+30, newHeight);
		}
		
		dstImg = new BufferedImage(srcImg.getWidth(), srcImg.getHeight(), BufferedImage.TYPE_INT_ARGB);
	}
	
	public void paint(Graphics g){
		super.paint(g);
		g.drawImage(srcImg,10, 50,  null);
		g.drawImage(dstImg, srcImg.getWidth()+10, 50,  null);	
	}
	
	public void filterConvolve(float[] values){
	}
	
	public void filterGray(){
		
	}
	
	public void filterChannel(){

	}
	
	public void filterSolarize(){
		
	}
	
	public void filterPointillize(){
		
	}
	
	public void filterInvert() {

		
	}
	
	public static void main(String[] args){
		ImageView v = new ImageView();
		v.setVisible(true);
	}
}
